import { computed } from 'vue';
const enumMap = {};
export function useEnum({ enum: enumList = [], enumMapperKey = 'default', disableEnumMapping, enumMapper }) {
    const mappedEnum = computed(() => {
        if (enumMapper)
            return enumMapper;
        let result = enumList.reduce((acc, item) => ({ ...acc, [item]: item }), {});
        if (!disableEnumMapping && enumMap?.[enumMapperKey])
            result = enumMap[enumMapperKey];
        return result;
    });
    return { mappedEnum };
}
export function setEnumMap(key = 'default', value) {
    enumMap[key] = value;
}
