import { setConfig } from './config';
import { setEnumMap } from './enum';
export const FormBuilderPlugin = {
    install: (_app, options) => {
        Object.entries(options.components ?? {}).forEach(([key, value]) => {
            setConfig(key, value);
        });
        Object.entries(options.enumMapper ?? {}).forEach(([key, value]) => {
            setEnumMap(key, value);
        });
    },
};
export { default as FormBuilder } from './FormBuilder.vue';
export * from './config';
export * from './enum';
export * from './FormBuilder.interface';
export * from './utils/defineForm.utils';
export * from './widgets';
export * from './utils/columns.utils';
export { default as ArrayWidgetVue } from './widgets/ArrayWidget.vue';
export * from './widgets/ArrayWidget.config';
export { default as BooleanWidgetVue } from './widgets/BooleanWidget.vue';
export * from './widgets/BooleanWidget.config';
export { default as NumberWidgetVue } from './widgets/NumberWidget.vue';
export * from './widgets/NumberWidget.config';
export { default as ObjectWidgetVue } from './widgets/ObjectWidget.vue';
export * from './widgets/ObjectWidget.config';
export { default as StringWidgetVue } from './widgets/StringWidget.vue';
export * from './widgets/StringWidget.config';
export { default as DateWidgetVue } from './widgets/DateWidget.vue';
export * from './widgets/DateWidget.config';
export { default as DateTimeWidgetVue } from './widgets/DateTimeWidget.vue';
export * from './widgets/DateTimeWidget.config';
export { default as FileWidgetVue } from './widgets/FileWidget.vue';
export * from './widgets/FileWidget.config';
export { default as PasswordWidgetVue } from './widgets/PasswordWidget.vue';
export * from './widgets/PasswordWidget.config';
export { default as SectionWidgetVue } from './widgets/SectionWidget.vue';
export * from './widgets/SectionWidget.config';
export { default as TextAreaWidgetVue } from './widgets/TextAreaWidget.vue';
export * from './widgets/TextAreaWidget.config';
export { default as CheckBoxWidgetVue } from './widgets/CheckBoxWidget.vue';
export * from './widgets/CheckBoxWidget.config';
