/* __placeholder__ */
import { deepClone, set } from '@codeperate/utils';
import { provide, ref, watch } from 'vue';
import { columnClass } from '../utils/columns.utils';
import { useFormWidget } from './FormWidget';
import { useConfig } from '../config';
const { defineProps, defineSlots, defineEmits, defineExpose, defineModel, defineOptions, withDefaults, } = await import('vue');
let __VLS_typeProps;
const props = withDefaults(defineProps(), useConfig('ArrayWidget', {
    addable: true,
    deletable: true,
    emptyText: 'No items',
    movable: true,
    joinValues: false,
    pagination: () => ({
        limit: 10,
    }),
    columns: 6,
    defaultItem: true,
    sortable: true,
}));
const fw = useFormWidget('ArrayWidget', props);
const { register, setValue, getPathArr, isValid, isRequired, value, schema, view, validator: defaultValidator, form } = fw;
const el = ref();
const validator = () => {
    defaultValidator();
    if (isRequired()) {
        if (value.value == null || value.value.length == 0)
            fw.validatedMeta.value.validity = false;
    }
    return fw.validatedMeta.value;
};
register({
    el: el,
    validator,
    onExportValue: async (exportedValue) => {
        set(exportedValue, ['value', ...fw.getPathArr()], value.value.filter(v => v));
    },
});
// onRenderTriggered(({ key, target, type }) => {
//     console.log(`Render triggered on component`, { key, target, type });
// });
const minusHandler = (i) => {
    if (value.value) {
        if (i != undefined)
            setValue(value.value.filter((_, index) => index != i));
        else
            setValue(value.value?.slice(i, -1));
    }
};
const addHandler = () => {
    setValue([...(value.value ?? []), undefined]);
};
if (props.defaultItem && value.value == undefined) {
    addHandler();
}
const dragIndex = ref(1);
const dragData = ref();
const dropIndex = ref();
const allowDrop = (to) => {
    dropIndex.value = to;
};
const dragStart = (target) => {
    dragIndex.value = target;
    dragData.value = deepClone(value.value[target]);
    dropIndex.value = undefined;
};
watch(dropIndex, (newVal, oldVal) => {
    if (newVal == undefined)
        return;
    value.value.splice(oldVal ?? dragIndex.value, 1);
    value.value.splice(newVal, 0, dragData.value);
    setValue([...value.value]);
});
provide('ArrayWidget', { inArrayWidget: true });
const componentProps = () => {
    let _props = schema['items']?.props ?? {};
    return typeof _props == 'function' ? _props({ form }) : _props;
};
const __VLS_withDefaultsArg = (function (t) { return t; })(useConfig('ArrayWidget', {
    addable: true,
    deletable: true,
    emptyText: 'No items',
    movable: true,
    joinValues: false,
    pagination: () => ({
        limit: 10,
    }),
    columns: 6,
    defaultItem: true,
    sortable: true,
}));
const __VLS_fnComponent = (await import('vue')).defineComponent({});
let __VLS_functionalComponentProps;
function __VLS_template() {
    let __VLS_ctx;
    /* Components */
    let __VLS_otherComponents;
    let __VLS_own;
    let __VLS_localComponents;
    let __VLS_components;
    let __VLS_styleScopedClasses;
    let __VLS_resolvedLocalAndGlobalComponents;
    __VLS_elementAsFunction(__VLS_intrinsicElements.div, __VLS_intrinsicElements.div)({ ...{ class: (([
                'cfb-p-2 cfb-rounded-lg cfb-grid cfb-gap-2',
                {
                    'cfb-bg-danger-200': __VLS_ctx.isValid() == false,
                    'cfb-bg-gray-50': __VLS_ctx.isValid() !== false,
                },
            ])) }, ref: ("el"), });
    // @ts-ignore
    (__VLS_ctx.el);
    __VLS_styleScopedClasses = ([
        'cfb-p-2 cfb-rounded-lg cfb-grid cfb-gap-2',
        {
            'cfb-bg-danger-200': isValid() == false,
            'cfb-bg-gray-50': isValid() !== false,
        },
    ]);
    if (!__VLS_ctx.view) {
        __VLS_elementAsFunction(__VLS_intrinsicElements.div, __VLS_intrinsicElements.div)({ ...{ class: ("cfb-flex cfb-justify-end cfb-gap-2") }, });
        __VLS_elementAsFunction(__VLS_intrinsicElements.button, __VLS_intrinsicElements.button)({ ...{ onClick: (...[$event]) => {
                    if (!((!__VLS_ctx.view)))
                        return;
                    __VLS_ctx.minusHandler();
                    // @ts-ignore
                    [isValid, isValid, el, view, minusHandler,];
                } }, ...{ class: ("cfb-bg-main-700 hover:cfb-bg-main-800 cfb-text-white cfb-w-8 cfb-flex cfb-justify-center cfb-items-center cfb-aspect-square cfb-px-4 cfb-py-1 cfb-rounded") }, });
        __VLS_elementAsFunction(__VLS_intrinsicElements.i, __VLS_intrinsicElements.i)({ ...{ class: ("fa-solid fa-minus") }, });
        __VLS_elementAsFunction(__VLS_intrinsicElements.button, __VLS_intrinsicElements.button)({ ...{ onClick: (__VLS_ctx.addHandler) }, ...{ class: ("cfb-bg-main-700 hover:cfb-bg-main-800 cfb-text-white cfb-w-8 cfb-flex cfb-justify-center cfb-items-center cfb-aspect-square cfb-px-4 cfb-py-1 cfb-rounded") }, });
        __VLS_elementAsFunction(__VLS_intrinsicElements.i, __VLS_intrinsicElements.i)({ ...{ class: ("fa-solid fa-plus") }, });
        // @ts-ignore
        [addHandler,];
    }
    __VLS_elementAsFunction(__VLS_intrinsicElements.div, __VLS_intrinsicElements.div)({ ...{ class: ((['cfb-grid des:cfb-grid-cols-12 mob:cfb-grid-cols-6 cfb-gap-4'])) }, });
    __VLS_styleScopedClasses = (['cfb-grid des:cfb-grid-cols-12 mob:cfb-grid-cols-6 cfb-gap-4']);
    if (__VLS_ctx.view && (!__VLS_ctx.value || __VLS_ctx.value?.filter(v => v).length == 0)) {
        __VLS_elementAsFunction(__VLS_intrinsicElements.div, __VLS_intrinsicElements.div)({ ...{ class: ("cfb-col-span-full") }, });
        __VLS_directiveFunction(__VLS_ctx.vHtml)((__VLS_ctx.emptyText));
        // @ts-ignore
        [view, value, value, vHtml, emptyText,];
    }
    if (__VLS_ctx.view && __VLS_ctx.joinValues) {
        __VLS_elementAsFunction(__VLS_intrinsicElements.div, __VLS_intrinsicElements.div)({});
        __VLS_directiveFunction(__VLS_ctx.vHtml)((__VLS_ctx.value?.join(',')));
        // @ts-ignore
        [view, value, vHtml, joinValues,];
    }
    else {
        for (const [_item, i] of __VLS_getVForSourceType((__VLS_ctx.view ? __VLS_ctx.value?.filter(v => v) : __VLS_ctx.value))) {
            __VLS_elementAsFunction(__VLS_intrinsicElements.div, __VLS_intrinsicElements.div)({ ...{ onDragstart: (...[$event]) => {
                        if (!(!((__VLS_ctx.view && __VLS_ctx.joinValues))))
                            return;
                        __VLS_ctx.dragStart(i);
                        // @ts-ignore
                        [view, value, value, dragStart,];
                    } }, ...{ onDragover: (...[$event]) => {
                        if (!(!((__VLS_ctx.view && __VLS_ctx.joinValues))))
                            return;
                        __VLS_ctx.allowDrop(i);
                        // @ts-ignore
                        [allowDrop,];
                    } }, key: ((i)), ...{ class: (([__VLS_ctx.columnClass(__VLS_ctx.columns), 'cfb-relative cfb-group cfb-p-2 hover:cfb-ring-2 hover:cfb-ring-main-700 cfb-rounded-lg'])) }, draggable: ((__VLS_ctx.sortable)), });
            __VLS_styleScopedClasses = ([columnClass(columns), 'cfb-relative cfb-group cfb-p-2 hover:cfb-ring-2 hover:cfb-ring-main-700 cfb-rounded-lg']);
            if (!__VLS_ctx.view) {
                __VLS_elementAsFunction(__VLS_intrinsicElements.button, __VLS_intrinsicElements.button)({ ...{ onClick: (...[$event]) => {
                            if (!(!((__VLS_ctx.view && __VLS_ctx.joinValues))))
                                return;
                            if (!((!__VLS_ctx.view)))
                                return;
                            __VLS_ctx.minusHandler(i);
                            // @ts-ignore
                            [view, minusHandler, columnClass, columns, sortable,];
                        } }, ...{ class: ("cfb-hidden group-hover:cfb-flex cfb-absolute -cfb-right-2 -cfb-top-2 cfb-bg-main-700 cfb-aspect-square cfb-items-center cfb-w-4 cfb-justify-center cfb-rounded-full cfb-text-white") }, });
                __VLS_elementAsFunction(__VLS_intrinsicElements.i, __VLS_intrinsicElements.i)({ ...{ class: ("fa-solid fa-xmark cfb-text-[10px]") }, });
            }
            const __VLS_0 = (__VLS_ctx.schema.items?.widget.component);
            // @ts-ignore
            const __VLS_1 = __VLS_asFunctionalComponent(__VLS_0, new __VLS_0({ path: (([...__VLS_ctx.getPathArr(), i].join('.'))), ...(__VLS_ctx.componentProps()), }));
            const __VLS_2 = __VLS_1({ path: (([...__VLS_ctx.getPathArr(), i].join('.'))), ...(__VLS_ctx.componentProps()), }, ...__VLS_functionalComponentArgsRest(__VLS_1));
            ({}({ path: (([...__VLS_ctx.getPathArr(), i].join('.'))), ...(__VLS_ctx.componentProps()), }));
            // @ts-ignore
            [schema, getPathArr, componentProps,];
            const __VLS_5 = __VLS_pickFunctionalComponentCtx(__VLS_0, __VLS_2);
        }
    }
    if (typeof __VLS_styleScopedClasses === 'object' && !Array.isArray(__VLS_styleScopedClasses)) {
        __VLS_styleScopedClasses['cfb-flex'];
        __VLS_styleScopedClasses['cfb-justify-end'];
        __VLS_styleScopedClasses['cfb-gap-2'];
        __VLS_styleScopedClasses['cfb-bg-main-700'];
        __VLS_styleScopedClasses['hover:cfb-bg-main-800'];
        __VLS_styleScopedClasses['cfb-text-white'];
        __VLS_styleScopedClasses['cfb-w-8'];
        __VLS_styleScopedClasses['cfb-flex'];
        __VLS_styleScopedClasses['cfb-justify-center'];
        __VLS_styleScopedClasses['cfb-items-center'];
        __VLS_styleScopedClasses['cfb-aspect-square'];
        __VLS_styleScopedClasses['cfb-px-4'];
        __VLS_styleScopedClasses['cfb-py-1'];
        __VLS_styleScopedClasses['cfb-rounded'];
        __VLS_styleScopedClasses['fa-solid'];
        __VLS_styleScopedClasses['fa-minus'];
        __VLS_styleScopedClasses['cfb-bg-main-700'];
        __VLS_styleScopedClasses['hover:cfb-bg-main-800'];
        __VLS_styleScopedClasses['cfb-text-white'];
        __VLS_styleScopedClasses['cfb-w-8'];
        __VLS_styleScopedClasses['cfb-flex'];
        __VLS_styleScopedClasses['cfb-justify-center'];
        __VLS_styleScopedClasses['cfb-items-center'];
        __VLS_styleScopedClasses['cfb-aspect-square'];
        __VLS_styleScopedClasses['cfb-px-4'];
        __VLS_styleScopedClasses['cfb-py-1'];
        __VLS_styleScopedClasses['cfb-rounded'];
        __VLS_styleScopedClasses['fa-solid'];
        __VLS_styleScopedClasses['fa-plus'];
        __VLS_styleScopedClasses['cfb-col-span-full'];
        __VLS_styleScopedClasses['cfb-hidden'];
        __VLS_styleScopedClasses['group-hover:cfb-flex'];
        __VLS_styleScopedClasses['cfb-absolute'];
        __VLS_styleScopedClasses['-cfb-right-2'];
        __VLS_styleScopedClasses['-cfb-top-2'];
        __VLS_styleScopedClasses['cfb-bg-main-700'];
        __VLS_styleScopedClasses['cfb-aspect-square'];
        __VLS_styleScopedClasses['cfb-items-center'];
        __VLS_styleScopedClasses['cfb-w-4'];
        __VLS_styleScopedClasses['cfb-justify-center'];
        __VLS_styleScopedClasses['cfb-rounded-full'];
        __VLS_styleScopedClasses['cfb-text-white'];
        __VLS_styleScopedClasses['fa-solid'];
        __VLS_styleScopedClasses['fa-xmark'];
        __VLS_styleScopedClasses['cfb-text-[10px]'];
    }
    var __VLS_slots;
    return __VLS_slots;
    const __VLS_componentsOption = {};
    let __VLS_name;
    let __VLS_defineComponent;
    const __VLS_internalComponent = __VLS_defineComponent({
        setup() {
            return {
                columnClass: columnClass,
                getPathArr: getPathArr,
                isValid: isValid,
                value: value,
                schema: schema,
                view: view,
                el: el,
                minusHandler: minusHandler,
                addHandler: addHandler,
                allowDrop: allowDrop,
                dragStart: dragStart,
                componentProps: componentProps,
            };
        },
        props: {},
    });
}
export default (await import('vue')).defineComponent({
    setup() {
        return {};
    },
    props: {},
});
;
