import { defineComponent as I, ref as L, reactive as O, computed as G, openBlock as s, createElementBlock as o, createElementVNode as l, unref as b, withModifiers as h, normalizeClass as q, Fragment as D, renderList as J, toDisplayString as d, normalizeStyle as K, createCommentVNode as C } from "vue";
import { byteSize as V } from "../utils/byte-size.utils.js";
import { useFormWidget as Q } from "./FormWidget.js";
import { set as X } from "@codeperate/utils";
const Y = { class: "cfb-grid" }, Z = ["required"], ee = {
  key: 0,
  class: "cfb-p-4 cfb-w-full cfb-grid cfb-grid-cols-1 tab:cfb-grid-cols-[repeat(auto-fill,20rem)] cfb-gap-4 cfb-place-self-start"
}, te = { class: "cfb-flex cfb-gap-4 cfb-rounded-lg cfb-p-1 cfb-w-full cfb-cursor-pointer" }, ie = ["src"], le = {
  key: 1,
  class: "cfb-w-20 cfb-shrink-0 cfb-rounded-lg cfb-aspect-square cfb-self-start cfb-bg-gray-100 cfb-flex cfb-justify-center cfb-items-center"
}, ae = /* @__PURE__ */ l("i", { class: "fa-solid fa-file cfb-text-[3rem] cfb-text-main-500" }, null, -1), re = [
  ae
], se = { class: "cfb-text-xs cfb-flex-shrink cfb-min-w-0 cfb-flex-col cfb-flex cfb-flex-grow" }, oe = { class: "cfb-text-sm cfb-break-words cfb-flex-grow cfb-mb-2" }, ne = {
  key: 0,
  class: "cfb-text-danger-600"
}, fe = { class: "cfb-self-end" }, ce = { class: "cfb-bg-gray-200 cfb-rounded-lg cfb-h-[4px] cfb-relative" }, de = { class: "" }, ue = [".disabled", "onClick"], be = /* @__PURE__ */ l("i", { class: "fa-solid fa-ban" }, null, -1), me = [
  be
], pe = {
  key: 1,
  class: "cfb-w-full cfb-justify-center cfb-grid cfb-items-center hover:cfb-bg-main-100 cfb-cursor-pointer cfb-rounded-lg"
}, ge = /* @__PURE__ */ l("i", { class: "fa-solid fa-folder cfb-text-[5rem]" }, null, -1), ve = { class: "cfb-flex cfb-justify-between cfb-px-2" }, ye = { class: "cfb-text-sm cfb-text cfb-text-main-600 cfb-grid" }, he = {
  key: 0,
  class: "cfb-text-danger-700"
}, xe = { key: 1 }, Ee = /* @__PURE__ */ I({
  __name: "FileWidget",
  props: {
    path: {},
    targetPath: {},
    required: { type: Boolean },
    validate: { type: Boolean },
    hidden: { type: Boolean },
    fileSizeBytesLimit: { default: 5e6 },
    fileSizeBytesLimitText: { type: Function, default: (c) => `Maximum upload size per file is ${V(c)}.` },
    fileNumberLimit: { default: 5 },
    fileSizeBytesLimitErr: { default: "Upload Failed - Size Exceeded" },
    fileNumberLimitText: { type: Function, default: (c) => `Maximum file upload limit is ${c}.` },
    fileNumberLimitErr: { default: "Upload Failed - Limit Exceeded" },
    fileRequiredErr: {},
    empty: { default: "N/A" },
    uploadText: { default: "Drag or click to upload" },
    uploadButton: { type: [Boolean, String], default: "Upload" },
    uploadFn: { type: Function, default: async (c, { progress: w }) => await new Promise(
      (r) => setTimeout(() => {
        w(100), r();
      }, 1e3)
    ) },
    mimeTypeLimit: {},
    mimeTypeLimitErr: { default: "Invalid file type" },
    mimeTypeLimitText: { type: Function, default: (c) => `Allowed file types are ${c.join(", ")}` },
    autoUpload: { type: Boolean, default: !1 },
    uploadOnExport: { type: Boolean }
  },
  setup(c, { expose: w }) {
    const r = c, {
      value: f,
      register: j,
      setValue: k,
      isRequired: E,
      form: A,
      validatedMeta: g,
      validate: B,
      validator: R,
      isValid: z,
      getPath: U
    } = Q("FileWidget", r), v = L(!1), m = L(!1), p = L(), F = new FileReader(), u = O(/* @__PURE__ */ new WeakMap()), y = L(""), S = G(() => {
      var e, t;
      return y.value || ((t = (e = g.value.err) == null ? void 0 : e[0]) == null ? void 0 : t.msg);
    }), N = async (e) => {
      let t = [], a;
      for (let i = 0; i < e.length; i++) {
        e[i].type.startsWith("image") && (F.readAsDataURL(e[i]), a = await new Promise((x) => {
          F.addEventListener("load", (_) => x(_.target.result), { once: !0 });
        })), t.push(e[i]);
        let n = {
          progress: 0
        };
        e[i].size > r.fileSizeBytesLimit && (n.error = r.fileSizeBytesLimitErr), r.mimeTypeLimit && !r.mimeTypeLimit.includes(e[i].type) && (n.error = r.mimeTypeLimitErr), a && (n.image = a), u.set(e[i], n);
      }
      return t;
    }, W = async (e) => {
      var a;
      if (!(e.target instanceof HTMLInputElement) || !e.target.files) return;
      if ((e.target.files.length ?? 0) + (((a = f.value) == null ? void 0 : a.length) ?? 0) > r.fileNumberLimit) {
        y.value = r.fileNumberLimitErr;
        return;
      }
      const t = await N(e.target.files);
      t.length > 0 && k(t), y.value = "", B();
    }, H = async (e) => {
      var i, n;
      const t = (i = e.dataTransfer) == null ? void 0 : i.files;
      if (!t) return;
      if ((t.length ?? 0) + (((n = f.value) == null ? void 0 : n.length) ?? 0) > r.fileNumberLimit) {
        y.value = r.fileNumberLimitErr;
        return;
      }
      const a = await N(t);
      k([...f.value ?? [], ...a]), m.value = !1, y.value = "", B();
    }, P = (e) => {
      k(f.value.filter((t) => t !== e)), p.value.value = "";
    }, T = async () => {
      v.value = !0;
      try {
        for (const e of f.value ?? []) {
          const t = u.get(e);
          t != null && t.error || await r.uploadFn(e, {
            progress: (a) => {
              t.progress = a;
            },
            form: A
          });
        }
      } catch (e) {
        throw v.value = !1, e;
      }
      v.value = !1;
    };
    return w({ upload: T }), j({
      upload: T,
      validator: () => {
        var e, t, a;
        return R(), E() && (((e = f.value) == null ? void 0 : e.length) ?? 0) <= 0 && (g.value.validity = !1, (t = p.value) == null || t.checkValidity(), (a = g.value).err ?? (a.err = [{ msg: p.value.validationMessage }])), g.value;
      },
      el: p,
      onExportValue: async (e) => {
        X(
          e,
          [
            "value",
            ...U().split(".").filter((t) => t)
          ],
          f.value
        ), r.uploadOnExport && await T();
      }
    }), (e, t) => {
      var a;
      return s(), o("div", Y, [
        l("input", {
          ref_key: "el",
          ref: p,
          onChange: W,
          class: "cfb-hidden",
          type: "file",
          multiple: !0,
          required: b(E)()
        }, null, 40, Z),
        l("div", {
          class: "cfb-px-2 cfb-py-1",
          onDrop: H,
          onClick: t[0] || (t[0] = (i) => {
            v.value || p.value.click();
          }),
          onDragover: t[1] || (t[1] = h((i) => m.value = !0, ["prevent"])),
          onDragenter: t[2] || (t[2] = h((i) => m.value = !0, ["prevent"])),
          onDragleave: t[3] || (t[3] = h((i) => m.value = !1, ["prevent"])),
          onDragend: t[4] || (t[4] = h((i) => m.value = !1, ["prevent"]))
        }, [
          l("div", {
            class: q([
              "cfb-min-h-[18rem] cfb-flex cfb-rounded-lg cfb-ring-2",
              { "cfb-bg-main-100": m.value },
              b(g).validity ? "cfb-ring-main-400" : "cfb-ring-danger-600"
            ])
          }, [
            (a = b(f)) != null && a.length ? (s(), o("div", ee, [
              (s(!0), o(D, null, J(b(f), (i) => {
                var n, x, _, M, $;
                return s(), o("div", te, [
                  (n = u.get(i)) != null && n.image ? (s(), o("img", {
                    key: 0,
                    class: "cfb-w-20 cfb-rounded-lg cfb-aspect-square cfb-object-cover cfb-self-start",
                    src: (x = u.get(i)) == null ? void 0 : x.image
                  }, null, 8, ie)) : (s(), o("div", le, re)),
                  l("div", se, [
                    l("div", oe, d(i.name), 1),
                    (_ = u.get(i)) != null && _.error ? (s(), o("div", ne, d((M = u.get(i)) == null ? void 0 : M.error), 1)) : (s(), o(D, { key: 1 }, [
                      l("div", fe, d(b(V)(i.size)), 1),
                      l("div", ce, [
                        l("div", {
                          class: "cfb-bg-main-500 cfb-absolute cfb-h-full",
                          style: K({ width: (($ = u.get(i)) == null ? void 0 : $.progress) + "%" })
                        }, null, 4)
                      ])
                    ], 64))
                  ]),
                  l("div", de, [
                    l("button", {
                      ".disabled": v.value,
                      class: "cfb-text-danger-600 hover:cfb-bg-gray-100 cfb-rounded-lg cfb-w-5 cfb-aspect-square disabled:cfb-text-gray-700",
                      onClick: h((_e) => P(i), ["stop"])
                    }, me, 40, ue)
                  ])
                ]);
              }), 256))
            ])) : (s(), o("div", pe, [
              l("div", {
                class: q([
                  "cfb-grid cfb-font-bold cfb-text-lg cfb-text-center cfb-gap-4",
                  { "cfb-text-danger-600": b(z)() == !1 },
                  { "cfb-text-main-500": b(z)() !== !1 }
                ])
              }, [
                ge,
                l("div", null, d(e.uploadText), 1)
              ], 2)
            ]))
          ], 2)
        ], 32),
        l("div", ve, [
          l("div", ye, [
            S.value ? (s(), o("div", he, d(S.value), 1)) : C("", !0),
            e.mimeTypeLimit ? (s(), o("div", xe, d(e.mimeTypeLimitText(e.mimeTypeLimit)), 1)) : C("", !0),
            l("div", null, d(e.fileSizeBytesLimitText(e.fileSizeBytesLimit)), 1),
            l("div", null, d(e.fileNumberLimitText(e.fileNumberLimit)), 1)
          ])
        ])
      ]);
    };
  }
});
export {
  Ee as default
};
